jQuery.event.special.inputchange = {
    setup: function () {
        var self = this, val;
        $.data(this, 'timer', window.setInterval(function () {
            val = self.value;
            if ($.data(self, 'cache') != val) {
                $.data(self, 'cache', val);
                $(self).trigger('inputchange');
            }
        }, 20));
    },
    teardown: function () {
        window.clearInterval($.data(this, 'timer'));
    },
    add: function () {
        $.data(this, 'cache', this.value);
    }
};


jQuery(document).ready(function () {
    var select_img = jQuery('#jform_params_images');
    var urlBase = jQuery('#base_url').val();
    var arr_image = jQuery('#jform_params_arrImage').val();

    if (arr_image == "") {
        var slide_items = [];
    } else {
        var slide_items = jQuery.parseJSON(arr_image);
    }

    getElementImg(slide_items);

    select_img.on('inputchange', function () {
        if (select_img.val() != "") {

            var item = {
                "url_image": urlBase + select_img.val(),
                "caption_link": ""
            };

            slide_items.push(item);

        }

        getElementImg(slide_items);
    });


    // save value when submit form
    Joomla.submitform = function (task, form) {
        if (typeof (form) === 'undefined' || form === null) {
            form = document.adminForm;
        }
        jQuery('.toolbox-saveConfig').trigger('click'); // dirty hack for megamenu save

        if (typeof (task) !== 'undefined') {
            form.task.value = task;
        }

        // Submit the form.
        if (typeof form.onsubmit == 'function') {
            form.onsubmit();
        }
        if (typeof form.fireEvent == "function") {
            form.fireEvent('submit');
        }

        ////build your data to save in here
        var order_item = Array();
        var numItems = jQuery('.showimg');
        var length = numItems.length;
        for (var i = 0; i < length; i++) {
            order_item[i] = numItems[i].id;
            slide_items[i].caption_link = jQuery('#cap_link' + i).val();


            for (var j = i; j < slide_items.length; j++) {
                if (order_item[i] == slide_items[j].order) {
                    var temp = slide_items[i];
                    slide_items[i] = slide_items[j];
                    slide_items[j] = temp;
                }
            }
        }

        var str = JSON.stringify(slide_items);
        jQuery('#jform_params_arrImage').val(str);

        form.submit();
    };


    function getElementImg(slide_items) {
        var div = jQuery('#wrap').html('');

        var num = slide_items.length;

        for (var i = 0; i < num; i++) {
            var item = slide_items[i];
            slide_items[i].order = i;
            var urlimg = '';
            urlimg = urlimg + '<a class="modal btn change_image" title="Select Image"';
            urlimg = urlimg + 'href="index.php?option=com_media&amp;view=images&amp;tmpl=component&amp;asset=134&amp;author=&amp;fieldid=urlimg' + i + '&amp;folder=" rel="{handler:';
            urlimg = urlimg + " 'iframe', size:";
            urlimg = urlimg + '{x: 800, y: 500}}">Select Image</a>';

            div.append('<div id="' + i + '" class="showimg" ></div>');
            var showimg = jQuery('#' + i);
            var html = '<div class="wrap_img"><img class="imageItem" src="' + item.url_image + '" id="imageItem' + i + '" /></div>';
            html = html + '<div class="wrap_link" id="wrap_link' + i + '" >';
            html = html + '<span>Link: </span>';
            html = html + '<input class="caption_link" type="text" id="cap_link' + i + '" value="' + item.caption_link + '"/>';
            html = html + '</div>';
            html = html + '<input type="text" id="urlimg' + i + '" class="urlimg hide" />';
            html = html + urlimg;

            html = html + '<input type="button" class="btn cancel btn-danger" id="btncancel' + i + '" value="Delete"/>';
            showimg.append(html);
        }

        jQuery('#wrap').sortable();
        jQuery(function ($) {
            SqueezeBox.initialize({});
            SqueezeBox.assign($('a.modal').get(), {
                parse: 'rel'
            });
        });

        jQuery('input.cancel').click(function () {
            if (confirm('Are you sure you want to delete?')) {
                var id = jQuery(this).parent().attr('id');
                jQuery(this).parent().remove();
                slide_items.splice(id, 1);
            }
        });

        jQuery('.urlimg').on('inputchange', function () {
            var url = urlBase + jQuery(this).val();
            var idthis = jQuery(this).attr('id');
            var id_img = idthis.replace('urlimg', '');
            slide_items[id_img].url_image = url;
            jQuery('#imageItem' + id_img).attr('src', url);
        });

        jQuery('.caption_link').on('inputchange', function () {
            var idthis = jQuery(this).attr('id');
            var id_caplink = idthis.replace('cap_link', '');
            slide_items[id_caplink].caption_link = jQuery(this).val();
        });

    }


});