<?php
/*
 * @version   1.2.3 Wed Mar 06 18:55:00 2013 +0100
 * @package   cSupport Live Chat Plugin
 * @author    cSupporthq[.com]
 * @copyright Copyright (C) cSupporthq[.com] and all rights reserved.
 * @license   GPL v3
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

class plgSystemPlugin_csupport extends JPlugin
{
	function plgSystemPlugin_csupport(&$subject, $config)
	{
		parent::__construct($subject, $config);
		
	}
	
	function onAfterRender()
	{
		$app = &JFactory::getApplication();
		
		$csupport_id = $this->params->get('csupport_id', '');
		
		if (strlen($csupport_id) < 1 || $app->isAdmin()) {
			return;
		}

		$buffer = JResponse::getBody();

		$csupport_type = $this->params->get('csupport_type', '');
		$csupport_autofill = $this->params->get('csupport_autofill', '');
		$csupport_autostart = $this->params->get('csupport_autostart', '');

		$csupport_position = $this->params->get('csupport_position', '');
		$csupport_margin = $this->params->get('csupport_margin', '');
		$csupport_bgcolor = $this->params->get('csupport_bgcolor', '');

		$add = '';

		// Add autofill
		if ($csupport_autofill=='true' || $csupport_autofill=='1')
		{
			$user =& JFactory::getUser();
			if (!$user->guest)
			{
				$add .= 'var cs_name="' . ($user->name) . '";var cs_email="' . ($user->email) . '";';
				if ($csupport_autostart=='true' || $csupport_autostart=='1')
				{
					$add .= 'var cs_autostart=true;';
				}
			}
		}

		// Add positioning
		if($csupport_position=='t-r' || $csupport_position=='t-l' || $csupport_position=='b-l' || $csupport_position=='b-r')
		{
			$add .= 'var cs_position="' . $csupport_position . '";';
		}

		// Add margin
		if (strlen($csupport_margin)>0 && is_numeric($csupport_margin))
		{
			if ($csupport_margin>100) $csupport_margin=100;
			elseif ($csupport_margin<-10) $csupport_margin=-10;
			$add .='var cs_margin="' . intVal($csupport_margin) . 'px";';	
		}

		// Add color
		if (preg_match('/^#[a-fA-F0-9]{6}(\/#[a-fA-F0-9]{6})?$/i', $csupport_bgcolor))
		{
			$add .= 'var cs_bgcolor="' . $csupport_bgcolor . '";';
		}

		// Create cSupport tag
		$csupport_tag = <<<EOF
<!-- START cSupport Live Chat Plugin --><script type="text/javascript">(function(d,c){var scrs=d.getElementsByTagName("script");var scr=scrs[scrs.length-1];var e=d.createElement("script");e.async=true;e.src=("https:"==document.location.protocol?"https://":"http://")+"$csupport_id/external/$csupport_type.js?"+scrs.length;if(typeof c=="function")if(e.addEventListener)e.addEventListener("load",c,false);else if(e.readyState)e.onreadystatechange=function(){if(this.readyState=="loaded")c();};scr.parentNode.insertBefore(e,scr);})(document,null);$add</script><!-- END cSupport Live Chat Plugin -->
EOF;
	
		$buffer = str_replace('</body>', $csupport_tag.'</body>', $buffer);
		
		JResponse::setBody($buffer);
		
		return true;
	}
}
?>